# mypy-boto3-pricing

[![PyPI - mypy-boto3-pricing](https://img.shields.io/pypi/v/mypy-boto3-pricing.svg?color=blue)](https://pypi.org/project/mypy-boto3-pricing)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-pricing.svg?color=blue)](https://pypi.org/project/mypy-boto3-pricing)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-pricing](#mypy-boto3-pricing)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.Pricing 1.13.24](https://boto3.amazonaws.com/v1/documentation/api/1.13.24/reference/services/pricing.html#Pricing) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-pricing](#mypy-boto3-pricing)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Pricing` service.

```bash
python -m pip install boto3-stubs[pricing]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_pricing` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_pricing import PricingClient

# Now mypy can check if your code is valid.
client: PricingClient = boto3.client("pricing")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: PricingClient = session.client("pricing")



# Annotated paginators are included as well

import mypy_boto3_pricing.paginator as pricing_paginators

describe_services_paginator: pricing_paginators.DescribeServicesPaginator = client.get_paginator("describe_services")
get_attribute_values_paginator: pricing_paginators.GetAttributeValuesPaginator = client.get_paginator("get_attribute_values")
get_products_paginator: pricing_paginators.GetProductsPaginator = client.get_paginator("get_products")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_pricing` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_pricing as pricing
from mypy_boto3_pricing import PricingClient

# with these
from mypy_boto3 import pricing
from mypy_boto3.pricing import PricingClient
```